=== debian/changelog ===
libhdf4 (4.2.12-3) unstable; urgency=medium

  * Team upload.
  * Fix symlink to directory conversion that happened in squeeze.
    (closes: #861303)
  * Update spelling-errors.patch to fix 'conversion' typo.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 27 Apr 2017 12:42:18 +0200

libhdf4 (4.2.12-2) unstable; urgency=medium

  * Team upload.
  * Enable PIE hardening flags.
    (closes: #859413)
  * Drop unused lintian overrides for hardening-no-pie.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 03 Apr 2017 14:28:06 +0200

libhdf4 (4.2.12-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 06 Jul 2016 17:35:38 +0200

libhdf4 (4.2.12-1~exp2) experimental; urgency=medium

  * Team upload.
  * Add Conflicts to -dev packages instead of Breaks/Replaces.
  * Drop quilt from build dependencies.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 01 Jul 2016 20:18:50 +0200

libhdf4 (4.2.12-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file, update copyright years for The HDF Group.
  * Drop unused ARCHIVE variable from rules file.
  * Drop obsolete README.source.
  * Refresh patches.
  * Drop install-examples.diff, no longer required.
  * Update symbols for version 4.2.12.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 01 Jul 2016 01:06:33 +0200
